<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="围栏名称" prop="fenceName">
        <el-input
          v-model="queryParams.fenceName"
          placeholder="请输入围栏名称"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="围栏状态" prop="fenceFlag">
        <el-select v-model="queryParams.fenceFlag" placeholder="请选择围栏状态" clearable>
          <el-option label="正常" value="1"></el-option>
          <el-option label="停用" value="2"></el-option>
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['fence:fence:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['fence:fence:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['fence:fence:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['fence:fence:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="fenceList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="围栏名称" align="center" prop="fenceName" />
      <el-table-column label="围栏类型" align="center" prop="fenceType" :formatter="fenceTypeFormatter" />
      <el-table-column label="围栏状态" align="center" prop="fenceFlag" :formatter="fenceFlagFormatter" />
      <el-table-column label="经纬度信息" align="center" prop="longitudeAndLatitudeInformation" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['fence:fence:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['fence:fence:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改电子围栏对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="750px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="100px">
        <el-form-item label="围栏名称" prop="fenceName">
          <el-input v-model="form.fenceName" placeholder="请输入围栏名称" />
        </el-form-item>
        <el-form-item label="围栏类型" prop="fenceType">
          <el-radio-group v-model="form.fenceType">
            <el-radio :label="1">驶入</el-radio>
            <el-radio :label="2">驶出</el-radio>
          </el-radio-group>
        </el-form-item>
        <el-form-item label="围栏状态" prop="fenceFlag">
          <el-select v-model="form.fenceFlag" placeholder="请选择围栏状态" clearable>
            <el-option label="正常" :value="1"></el-option>
            <el-option label="停用" :value="2"></el-option>
          </el-select>
        </el-form-item>

        <el-form-item v-if="form.fencePriority != null" label="优先级回显" prop="fencePriority">
          <el-input v-model="form.fencePriority" placeholder="请输入围栏优先级" />
        </el-form-item>

        <el-form-item label="优先级" prop="fencePriority">
          <el-transfer
            v-model="selectedGroups"
            :data="transferData"
            :titles="['围栏组', '优先级']"
            style="margin-top: 15px;"
          ></el-transfer>
        </el-form-item>



        <el-form-item label="经纬度信息" prop="longitudeAndLatitudeInformation">
          <el-input v-model="form.longitudeAndLatitudeInformation" placeholder="请输入经纬度信息" />
          <el-button type="primary" @click="openDialog">选择经纬度</el-button>
        </el-form-item>

      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>

    <el-dialog :title="'选择经纬度信息'" :visible.sync="showLocationDialog" width="600px">
      <select-location @locationSelected="handleLocationSelected"></select-location>
    </el-dialog>




  </div>
</template>

<script>
import { listFence, getFence, delFence, addFence, updateFence } from "/src/api/fence/fence";
import SelectLocation from '@/components/SelectLocation.vue'
import { selectGroupList } from '@/api/fence/group'

export default {
  name: "Fence",
  components:{
    SelectLocation
  },
  data() {
    return {
      //定义围栏组集合
      group:[],
      // el-transfer 的数据源
      transferData: [],
      // el-transfer 的当前选择值,用于存储选中的围栏组编号
      selectedGroups: [],



      showLocationDialog:false,
      selectedLocation:null,

      // openLocationDialogVisible:false,// 用于控制选择经纬度对话框的显示
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 电子围栏表格数据
      fenceList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        fenceName: null,
        fenceType: null,
        fenceFlag: null,
        longitudeAndLatitudeInformation: null,
        fencePriority: null,
      },
      // 表单参数
      form: {
        fenceId:null,
        fenceName:'',
        fenceType:null,// 确保类型正确，字符串或数字，取决于您实际的数据类型
        fenceFlag:null,
        fencePriority: null, // 初始化为 null
        longitudeAndLatitudeInformation:[]
      },
      // 表单校验
      rules: {
      }
    };
  },
  // 对话框页面的组件
  computed: {
    selectedLongitudeAndLatitude() {
      return this.$store.state.selectedLongitudeAndLatitude;
    }
  },
  watch: {
    selectedLongitudeAndLatitude(newValue) {
      if (newValue) {
        this.form.longitudeAndLatitudeInformation = newValue;
      }
    }
  },
  created() {
    this.getList();
    this.getGroupList();
  },
  methods: {

    //查询围栏组集合
    getGroupList() {
      selectGroupList().then(response => {
        this.group = response.data;
        // 格式化数据
        if (Array.isArray(response.data)) {
          this.transferData = response.data.map((item, index) => ({
            key: item.groupId ? item.groupId.toString() : `defaultKey${index}`, // 使用默认键值
            label: item.groupName || `Group ${index}`
          }));
        } else {
          console.error('Response data is not an array:', response.data);
          this.transferData = [];
        }

        // 确保 selectedGroups 包含正确的数据
        if (this.form.fencePriority) {
          try {
            const parsedPriority = JSON.parse(this.form.fencePriority);
            this.selectedGroups = parsedPriority.map(Number);
          } catch (error) {
            console.error('解析 fencePriority 错误:', error);
          }
        }
      }).catch(error => {
        console.error('Error fetching group list:', error);
        this.transferData = [];
      });
    },
    /** 查询电子围栏列表 */
    getList() {
      this.loading = true;
      listFence(this.queryParams).then(response => {
        this.fenceList = response.data.rows;
        this.total = response.data.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        fenceId: null,
        fenceName: null,
        fenceType: null,
        fenceFlag: null,
        longitudeAndLatitudeInformation: null,
        fencePriority: null,
        createBy: null,
        createTime: null,
        updateBy: null,
        updateTime: null,
        remark: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.fenceId)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加电子围栏";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const fenceId = row.fenceId || this.ids
      getFence(fenceId).then(response => {
        console.log(response.data);// 打印数据确认内容
        this.form = response.data;
        this.open = true;
        this.title = "修改电子围栏";
      });
    },
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          // 将 selectedGroups 转换为 JSON 格式并赋值给 form.fencePriority
          this.form.fencePriority = JSON.stringify(this.selectedGroups);

          if (this.form.fenceId != null) {
            updateFence(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addFence(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },


    /** 删除按钮操作 */
    handleDelete(row) {
      const fenceIds = row.fenceId || this.ids;
      this.$modal.confirm('是否确认删除电子围栏编号为"' + fenceIds + '"的数据项？').then(function() {
        return delFence(fenceIds);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('fence/fence/export', {
        ...this.queryParams
      }, `fence_${new Date().getTime()}.xlsx`)
    },

    fenceTypeFormatter(row,column,value) {
      return value == '1' ?'驶入' :'驶出';
    },
    fenceFlagFormatter(row,column,value) {
      return value == '1' ?'正常' :'停用';
    },



    openDialog() {
      this.showLocationDialog = true;
      // 设置过几秒后关闭弹框
      setTimeout(() => {
        this.showLocationDialog = false; // 关闭弹框
      }, 10000); // 这里的 3000 毫秒等于 3 秒
    },
    handleLocationSelected(location) {
      this.showLocationDialog = false;
      if (location) {
        this.form.longitudeAndLatitudeInformation = `${location.lng},${location.lat}`;
      }
    },


  },
}

</script>
